#ifndef TERMINALCOMMUNICATION_H
#define TERMINALCOMMUNICATION_H


#include <QtSerialPort>
#include <QTimer>

class TerminalCommunication : public QObject
{
    Q_OBJECT
public slots:
    void readData();
    void receiveTimeout();
    void HandleError(QSerialPort::SerialPortError error);

signals:
    void LineReceived(QString ReceivedLine);

public:
    TerminalCommunication();
    TerminalCommunication(int VendorID, int ProductID);

    ~TerminalCommunication();

    void SendLine(QString String);
    void SendByteArray(const QByteArray Array);

    bool ConnectToSerialDevice(int VendorID, int ProductID);
    void DisconnectSerialDevice();
    bool isOpen();
    void setReceiveTimeout(int TimeoutInMs);

    void Flush();

    void ListPorts();

private:
    QSerialPort * SerialPort;
	QSerialPortInfo * PortInfo;

    //QTimer UpdateTimer;

    QTimer ReceiveTimeoutTimer;
    QByteArray ReceiveBuffer;
};

#endif // TERMINALCOMMUNICATION_H
